%define rname NetworkManager
%define ppp_version 2.4.7

%define api		1.0
%define major_glib	4
%define major_glib_vpn	1
%define major_util	2
%define major_libnm	0
%define libnm_glib	%mklibname nm-glib %{major_glib}
%define devnm_glib	%mklibname nm-glib -d
%define libnm_glib_vpn	%mklibname nm-glib-vpn %{major_glib_vpn}
%define devnm_glib_vpn	%mklibname nm-glib-vpn -d
%define libnm_util	%mklibname nm-util %{major_util}
%define devnm_util	%mklibname nm-util -d
%define libnm		%mklibname nm %{major_libnm}
%define girnm		%mklibname nm-gir %{api}
%define devnm		%mklibname nm -d

%define girclient	%mklibname nmclient-gir %{api}
%define girname		%mklibname %{name}-gir %{api}

%{?build_selinux}%{?!build_selinux:%bcond_with selinux}

Summary:	Network connection manager and user applications
Name:		networkmanager
Version:	1.4.4
Release:	7
License:	GPLv2+
Group:		System/Base
Url:		http://www.gnome.org/projects/NetworkManager/
Source0:	http://ftp.gnome.org/pub/GNOME/sources/NetworkManager/1.2/%{rname}-%{version}.tar.xz
Source4:	networkmanager-tmpfiles.conf
# Rosa specific patches
Patch0:		networkmanager-0.9.10.0-systemd-service.patch
Patch1:		networkmanager-1.2.2-dhcpcd-verbose-output.patch
Patch2:		networkmanager-1.2.2-link-ifcfg-rh-with-selinux.patch
Patch3:		networkmanager-1.2.2-ppp-default-mtu.patch
# Backported from upstream
# https://bugzilla.gnome.org/show_bug.cgi?id=768973
Patch4:		networkmanager-1.2.2-mtu-fix.patch
# Backported from upstream
Patch5:		networkmanager-1.4.4-sfmt.patch

BuildRequires:	gtk-doc
BuildRequires:	intltool
BuildRequires:	iptables
BuildRequires:	systemd >= 194-25
BuildRequires:	wpa_supplicant >= 1.1-3
BuildRequires:	libiw-devel
BuildRequires:	readline-devel
BuildRequires:	ppp-devel = %{ppp_version}
BuildRequires:	pkgconfig(dbus-glib-1)
BuildRequires:	pkgconfig(ext2fs)
BuildRequires:	pkgconfig(glibmm-2.4)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(gudev-1.0)
BuildRequires:	pkgconfig(libndp)
BuildRequires:	pkgconfig(libnl-3.0)
BuildRequires:	pkgconfig(libsoup-2.4)
%if %{mdvver} >= 201610
BuildRequires:	pkgconfig(libsystemd)
%else
BuildRequires:	pkgconfig(libsystemd-daemon)
BuildRequires:	pkgconfig(libsystemd-journal)
BuildRequires:	pkgconfig(libsystemd-login)
%endif
BuildRequires:	pkgconfig(mm-glib)
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(nss)
BuildRequires:	pkgconfig(polkit-gobject-1)
BuildRequires:	pkgconfig(systemd)
BuildRequires:	pkgconfig(uuid)
%if %{with selinux}
BuildRequires:	pkgconfig(libsepol)
BuildRequires:	pkgconfig(libselinux)
%endif

# Just to make sure we have typelibs installed
Requires:	%{girclient} = %{EVRD}
Requires:	%{girname} = %{EVRD}
Requires:	dhcp-client
Requires:	dnsmasq-base
Requires:	iproute2
Requires:	iptables
Requires:	mobile-broadband-provider-info
Requires:	modemmanager >= 1.0.0-4
Suggests:	nscd
Requires:	ppp = %(rpm -q --queryformat "%{VERSION}" ppp )
Requires:	systemd >= 194-25
Requires:	wireless-tools
Requires:	wpa_supplicant >= 1.1-3
Requires(post,preun):	rpm-helper
Requires(post,preun):	systemd
Requires(postun):	systemd
Provides:	NetworkManager = %{EVRD}
Conflicts:	%{_lib}nm_util1 < 0.7.996
Conflicts:	initscripts < 9.24-5

%description
NetworkManager attempts to keep an active network connection available at all
times. It is intended only for the desktop use-case, and is not intended for
usage on servers. The point of NetworkManager is to make networking
configuration and setup as painless and automatic as possible. If using DHCP,
NetworkManager is _intended_ to replace default routes, obtain IP addresses
from a DHCP server, and change nameservers whenever it sees fit.

%files -f %{rname}.lang
%doc AUTHORS CONTRIBUTING ChangeLog NEWS README TODO
%doc %{_datadir}/doc/NetworkManager/examples/server.conf
%{_sysconfdir}/dbus-1/system.d/org.freedesktop.NetworkManager.conf
%{_sysconfdir}/dbus-1/system.d/nm-dispatcher.conf
%{_sysconfdir}/dbus-1/system.d/nm-ifcfg-rh.conf
%dir %{_sysconfdir}/%{rname}
%config(noreplace) %{_sysconfdir}/%{rname}/NetworkManager.conf
%config(noreplace) %{_sysconfdir}/netprofile/modules/01_networkmanager
%dir %{_sysconfdir}/%{rname}/conf.d
%{_sbindir}/%{rname}
%dir %{_sysconfdir}/%{rname}/dispatcher.d
%dir %{_sysconfdir}/%{rname}/system-connections
%dir %{_sysconfdir}/NetworkManager/VPN
%{_bindir}/nmcli
%{_bindir}/nm-online
%{_libexecdir}/nm-dhcp-helper
%{_libexecdir}/nm-dispatcher
%{_libexecdir}/nm-iface-helper
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man7/*.7*
%{_mandir}/man8/*.8*
%dir %{_libdir}/NetworkManager
%{_libdir}/NetworkManager/*.so
%{_libdir}/pppd/*.*.*/nm-pppd-plugin.so
%ghost %attr(0755,root,root) %{_localstatedir}/run/%{rname}
%{_tmpfilesdir}/%{name}.conf
%dir %{_localstatedir}/lib/%{rname}
%ghost %{_localstatedir}/lib/%{rname}/*
%{_datadir}/dbus-1/system-services/org.freedesktop.nm_dispatcher.service
%{_datadir}/polkit-1/actions/org.freedesktop.NetworkManager.policy
%{_udevrulesdir}/*.rules
%{_systemunitdir}/NetworkManager-wait-online.service
%{_systemunitdir}/NetworkManager.service
%{_systemunitdir}/networkmanager.service
%{_systemunitdir}/NetworkManager-dispatcher.service
%{_unitdir}/dbus-org.freedesktop.nm-dispatcher.service
%{_systemunitdir}/network-online.target.wants/NetworkManager-wait-online.service
%{_datadir}/dbus-1/system-services/org.freedesktop.NetworkManager.service
%{_datadir}/bash-completion/completions/nmcli

#Update config files from previous
%triggerin -- %{name} < %{version}-%{release}
sed -e 's/ifcfg-mdv/ifcfg-rh/' -i /etc/NetworkManager/NetworkManager.conf

%post
%systemd_post NetworkManager.service
%systemd_post NetworkManager-dispatcher.service
%tmpfiles_create %{_tmpfilesdir}/%{name}.conf
#Use NM only by default
if grep -q 'USE_NM_ONLY=' /etc/sysconfig/network; then
	sed -e 's/USE_NM_ONLY=no/USE_NM_ONLY=yes/' -i /etc/sysconfig/network
else
	echo "USE_NM_ONLY=yes" >> /etc/sysconfig/network
fi

%preun
%systemd_preun NetworkManager.service
%systemd_preun NetworkManager-dispatcher.service
if [ $1 -eq 0 ] ; then \
	# Package removal, not upgrade \
	sed -e 's/USE_NM_ONLY=yes/USE_NM_ONLY=no/' -i /etc/sysconfig/network
fi

%postun
%systemd_postun

#----------------------------------------------------------------------------

%package -n %{libnm_util}
Summary:	Shared library for nm_util
Group:		System/Libraries

%description -n %{libnm_util}
Shared library for nm-util.

%files -n %{libnm_util}
%{_libdir}/libnm-util.so.%{major_util}*

#----------------------------------------------------------------------------

%package -n %{girname}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Requires:	%{libnm_util} = %{EVRD}
Conflicts:	%{_lib}nm-util2 < 1.4.4-5

%description -n %{girname}
GObject Introspection interface description for Network Manager.

%files -n %{girname}
%{_libdir}/girepository-1.0/NetworkManager-%{api}.typelib

#----------------------------------------------------------------------------

%package -n %{devnm_util}
Summary:	Development files for nm_util
Group:		Development/C
Requires:	%{libnm_util} = %{EVRD}
Requires:	%{girname} = %{EVRD}
Provides:	NetworkManager-devel = %{EVRD}
Provides:	nm-util-devel = %{EVRD}
Provides:	libnm-util-devel = %{EVRD}

%description -n %{devnm_util}
Development files for nm-util.

%files -n %{devnm_util}
%dir %{_includedir}/%{rname}
%{_includedir}/%{rname}/*.h
%doc %{_datadir}/gtk-doc/html/%{rname}
%doc %{_datadir}/gtk-doc/html/libnm-util
%{_datadir}/gir-1.0/NetworkManager-%{api}.gir
%{_libdir}/pkgconfig/%{rname}.pc
%{_libdir}/pkgconfig/libnm-util.pc
%{_libdir}/libnm-util.so

#----------------------------------------------------------------------------

%package -n %{libnm_glib}
Summary:	Shared library for nm_glib
Group:		System/Libraries

%description -n %{libnm_glib}
This package contains the libraries that make it easier to use some
NetworkManager functionality from applications that use glib.

%files -n %{libnm_glib}
%{_libdir}/libnm-glib.so.%{major_glib}*

#----------------------------------------------------------------------------

%package -n %{girclient}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Requires:	%{libnm_glib} = %{EVRD}
Conflicts:	%{_lib}nm-glib4 < 1.4.4-5

%description -n %{girclient}
GObject Introspection interface description for NM Client.

%files -n %{girclient}
%{_libdir}/girepository-1.0/NMClient-%{api}.typelib

#----------------------------------------------------------------------------

%package -n %{devnm_glib}
Summary:	Development files for nm_glib
Group:		Development/C
Requires:	%{libnm_glib} = %{EVRD}
Requires:	%{girclient} = %{EVRD}
Provides:	nm-glib-devel = %{EVRD}
Provides:	libnm-glib-devel = %{EVRD}
Provides:	NetworkManager-glib-devel = %{EVRD}

%description -n %{devnm_glib}
Development files for nm-glib.

%files -n %{devnm_glib}
%dir %{_includedir}/libnm-glib
%exclude %{_includedir}/libnm-glib/nm-vpn*.h
%doc %{_datadir}/gtk-doc/html/libnm-glib
%{_includedir}/libnm-glib/*.h
%{_libdir}/pkgconfig/libnm-glib.pc
%{_libdir}/libnm-glib.so
%{_datadir}/gir-1.0/NMClient-%{api}.gir

#----------------------------------------------------------------------------

%package -n %{libnm_glib_vpn}
Summary:	Shared library for nm-glib-vpn
Group:		System/Libraries

%description -n %{libnm_glib_vpn}
This package contains the libraries that make it easier to use some
NetworkManager VPN functionality from applications that use glib.

%files -n %{libnm_glib_vpn}
%{_libdir}/libnm-glib-vpn.so.%{major_glib_vpn}*

#----------------------------------------------------------------------------

%package -n %{devnm_glib_vpn}
Summary:	Development files for nm-glib-vpn
Group:		Development/C
Requires:	%{libnm_glib_vpn} = %{EVRD}
Provides:	nm-glib-vpn-devel = %{EVRD}
Provides:	libnm-glib-vpn-devel = %{EVRD}

%description -n %{devnm_glib_vpn}
Development files for nm-glib-vpn.

%files -n %{devnm_glib_vpn}
%{_includedir}/libnm-glib/nm-vpn*.h
%{_libdir}/pkgconfig/libnm-glib-vpn.pc
%{_libdir}/libnm-glib-vpn.so

#----------------------------------------------------------------------------

%package -n %{libnm}
Summary:	Shared library for nm_util
Group:		System/Libraries

%description -n %{libnm}
Shared library for nm.

%files -n %{libnm}
%{_libdir}/libnm.so.%{major_libnm}*

#----------------------------------------------------------------------------

%package -n %{girnm}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Requires:	%{libnm} = %{EVRD}

%description -n %{girnm}
GObject Introspection interface description for NM.

%files -n %{girnm}
%{_libdir}/girepository-1.0/NM-%{api}.typelib

#----------------------------------------------------------------------------

%package -n %{devnm}
Summary:	Development files for NM
Group:		Development/C
Requires:	%{libnm} = %{EVRD}
Requires:	%{girnm} = %{EVRD}
Provides:	nm-devel = %{EVRD}

%description -n %{devnm}
Development files for NM.

%files -n %{devnm}
%dir %{_includedir}/libnm
%{_includedir}/libnm/*.h
%doc %{_datadir}/gtk-doc/html/libnm
%{_datadir}/gir-1.0/NM-%{api}.gir
%{_libdir}/pkgconfig/libnm.pc
%{_libdir}/libnm.so

#----------------------------------------------------------------------------

%prep
%setup -q -n %{rname}-%{version}
%apply_patches

%build
%define _disable_ld_no_undefined 1
autoreconf -f
%configure2_5x \
	--disable-static \
	--disable-rpath \
	--with-crypto=nss \
	--enable-more-warnings=no \
	--with-docs=yes \
	--with-system-ca-path=%{_sysconfdir}/pki/tls/certs \
	--with-resolvconf=no \
	--with-session-tracking=systemd \
	--with-suspend-resume=systemd \
	--with-systemdsystemunitdir=%{_systemunitdir} \
	--with-tests=yes \
	--with-dhcpcd=/sbin/dhcpcd \
	--with-dhclient=/sbin/dhclient \
	--with-iptables=/sbin/iptables \
	--enable-bluez4 \
	--enable-polkit \
	--enable-polkit-agent \
	--enable-ppp \
	--enable-concheck \
	--with-wext=yes \
	--enable-modify-system \
	--with-modem-manager-1 \
	--with-vala=yes \
	--with-udev-dir=/lib/udev \
	--with-system-libndp=yes \
	--with-teamdctl \
%if %{with selinux}
	--with-selinux=yes \
%endif
	--enable-introspection=yes \
	--with-pppd-plugin-dir=%{_libdir}/pppd/%{ppp_version} \
	--with-dist-version=%{version}-%{release}

%make

%install
%makeinstall_std

cat > %{buildroot}%{_sysconfdir}/NetworkManager/NetworkManager.conf << EOF
[main]
plugins=ifcfg-rh,keyfile

[device]
wifi.scan-rand-mac-address=no
EOF

# Create netprofile module 
install -d %{buildroot}%{_sysconfdir}/netprofile/modules/
cat > %{buildroot}%{_sysconfdir}/netprofile/modules/01_networkmanager << EOF
# netprofile module
#
# this module contains settings for saving/restore the NetworkManager configuration
# in different network profiles

NAME="networkmanager"
DESCRIPTION="Networkmanager connection settings"

# list of files to be saved by netprofile
FILES="/etc/NetworkManager/"

# list of services to be restarted by netprofile
SERVICES="networkmanager"
EOF
chmod  755 %{buildroot}%{_sysconfdir}/netprofile/modules/01_networkmanager

install -d %{buildroot}%{_sysconfdir}/NetworkManager/conf.d

# create a VPN directory
install -d %{buildroot}%{_sysconfdir}/%{rname}/VPN
install -m755 clients/.libs/nm-online -D %{buildroot}%{_bindir}/nm-online

# create keyfile plugin system-settings directory
install -d %{buildroot}%{_sysconfdir}/%{rname}/system-connections


# create a dnsmasq.d directory
install -d %{buildroot}%{_sysconfdir}/NetworkManager/dnsmasq.d
install -d %{buildroot}%{_datadir}/gnome-vpn-properties
install -d %{buildroot}%{_localstatedir}/lib/NetworkManager

# link service file to match alias
ln -sf %{_systemunitdir}/%{rname}.service %{buildroot}%{_systemunitdir}/%{name}.service
#rhbz#974811
ln -sr %{buildroot}%{_unitdir}/NetworkManager-dispatcher.service %{buildroot}%{_unitdir}/dbus-org.freedesktop.nm-dispatcher.service

# (bor) clean up on uninstall
install -d %{buildroot}%{_localstatedir}/lib/%{rname}
pushd %{buildroot}%{_localstatedir}/lib/%{rname} && {
	touch %{rname}.state
	touch timestamps
popd
}

#install tmpfiles conf
install -m644 -D %{SOURCE4} %{buildroot}%{_tmpfilesdir}/%{name}.conf

%find_lang %{rname}


%changelog
